Index: trunk/lib/FlairCore/src/RangeFinderPlot.h
===================================================================
--- trunk/lib/FlairCore/src/RangeFinderPlot.h	(revision 14)
+++ trunk/lib/FlairCore/src/RangeFinderPlot.h	(revision 15)
@@ -5,5 +5,6 @@
 /*!
  * \file RangeFinderPlot.h
- * \brief Class displaying a 2D plot on the ground station for laser range finder like Hokuyo
+ * \brief Class displaying a 2D plot on the ground station for laser range
+ * finder like Hokuyo
  * \author Guillaume Sanahuja, Copyright Heudiasyc UMR UTC/CNRS 7253
  * \date 2014/07/23
@@ -17,77 +18,75 @@
 #include <stdint.h>
 
-namespace flair
-{
-    namespace core
-    {
-        class cvmatrix;
-    }
+namespace flair {
+namespace core {
+class cvmatrix;
+}
 }
 
-namespace flair
-{
-namespace gui
-{
+namespace flair {
+namespace gui {
 
-    class LayoutPosition;
+class LayoutPosition;
 
-    /*! \class RangeFinderPlot
-    *
-    * \brief Class displaying a 2D plot on the ground station for laser range finder like Hokuyo
-    *
-    */
-    class RangeFinderPlot: public SendData
-    {
-        public:
-            /*!
-            * \brief Constructor
-            *
-            * Construct a 2D plot at given position. \n
-            * The RangeFinderPlot will automatically be child of position->getLayout() Layout. After calling this constructor,
-            * position will be deleted as it is no longer usefull.
-            *
-            * \param position position to display the plot
-            * \param name name
-            * \param x_name name of x axis
-            * \param xmin default xmin of the plot
-            * \param xmax default xmax of the plot
-            * \param y_name name of y axis
-            * \param ymin default ymin of the plot
-            * \param ymax default ymax of the plot
-            * \param datas laser datas
-            * \param start_angle start angle of the laser
-            * \param end_angle end angle of the laser
-            * \param nb_samples number of samples
-            */
-            RangeFinderPlot(const LayoutPosition* position,std::string name,
-                            std::string x_name,float xmin,float xmax,
-                            std::string y_name,float ymin,float ymax,
-                            const core::cvmatrix* datas,float start_angle,float end_angle,uint32_t nb_samples);
+/*! \class RangeFinderPlot
+*
+* \brief Class displaying a 2D plot on the ground station for laser range finder
+*like Hokuyo
+*
+*/
+class RangeFinderPlot : public SendData {
+public:
+  /*!
+  * \brief Constructor
+  *
+  * Construct a 2D plot at given position. \n
+  * The RangeFinderPlot will automatically be child of position->getLayout()
+  *Layout. After calling this constructor,
+  * position will be deleted as it is no longer usefull.
+  *
+  * \param position position to display the plot
+  * \param name name
+  * \param x_name name of x axis
+  * \param xmin default xmin of the plot
+  * \param xmax default xmax of the plot
+  * \param y_name name of y axis
+  * \param ymin default ymin of the plot
+  * \param ymax default ymax of the plot
+  * \param datas laser datas
+  * \param start_angle start angle of the laser
+  * \param end_angle end angle of the laser
+  * \param nb_samples number of samples
+  */
+  RangeFinderPlot(const LayoutPosition *position, std::string name,
+                  std::string x_name, float xmin, float xmax,
+                  std::string y_name, float ymin, float ymax,
+                  const core::cvmatrix *datas, float start_angle,
+                  float end_angle, uint32_t nb_samples);
 
-            /*!
-            * \brief Destructor
-            *
-            */
-            ~RangeFinderPlot();
+  /*!
+  * \brief Destructor
+  *
+  */
+  ~RangeFinderPlot();
 
-        private:
-            /*!
-            * \brief Copy datas to specified buffer
-            *
-            * Reimplemented from SendData.
-            *
-            * \param buf output buffer
-            */
-            void CopyDatas(char* buf) const;
+private:
+  /*!
+  * \brief Copy datas to specified buffer
+  *
+  * Reimplemented from SendData.
+  *
+  * \param buf output buffer
+  */
+  void CopyDatas(char *buf) const;
 
-            /*!
-            * \brief Extra Xml event
-            *
-            * Reimplemented from SendData.
-            */
-            void ExtraXmlEvent(void){};
+  /*!
+  * \brief Extra Xml event
+  *
+  * Reimplemented from SendData.
+  */
+  void ExtraXmlEvent(void){};
 
-            const core::cvmatrix* datas;
-    };
+  const core::cvmatrix *datas;
+};
 
 } // end namespace gui
Index: trunk/lib/FlairCore/src/RotationMatrix.cpp
===================================================================
--- trunk/lib/FlairCore/src/RotationMatrix.cpp	(revision 14)
+++ trunk/lib/FlairCore/src/RotationMatrix.cpp	(revision 15)
@@ -21,53 +21,49 @@
 #include "math.h"
 
-namespace flair
-{
-namespace core
-{
+namespace flair {
+namespace core {
 
 RotationMatrix::RotationMatrix() {
-    for(int i=0;i<3;i++) {
-        for(int j=0;j<3;j++) {
-            if(i==j) {
-                m[i][j]=1;
-            }else {
-                m[i][j]=0;
-            }
-        }
+  for (int i = 0; i < 3; i++) {
+    for (int j = 0; j < 3; j++) {
+      if (i == j) {
+        m[i][j] = 1;
+      } else {
+        m[i][j] = 0;
+      }
     }
+  }
 }
 
-RotationMatrix::~RotationMatrix() {
-
-}
+RotationMatrix::~RotationMatrix() {}
 
 void RotationMatrix::ToEuler(Euler &euler) const {
-    euler.roll=atanf(m[1][2]/m[2][2]);
-    euler.pitch=asinf(-m[0][2]);
-    euler.yaw=atan2f(m[0][1],m[0][0]);
+  euler.roll = atanf(m[1][2] / m[2][2]);
+  euler.pitch = asinf(-m[0][2]);
+  euler.yaw = atan2f(m[0][1], m[0][0]);
 }
 
 Euler RotationMatrix::ToEuler(void) const {
-    Euler euler;
-    ToEuler(euler);
-    return euler;
+  Euler euler;
+  ToEuler(euler);
+  return euler;
 }
 
-float& RotationMatrix::operator()(size_t row,size_t col) {
-    if(row<3 && col<3) {
-        return m[row][col];
-    } else {
-        Printf("RotationMatrix: index (%i,%i) out of bound\n",row,col);
-        return m[2][2];
-    }
+float &RotationMatrix::operator()(size_t row, size_t col) {
+  if (row < 3 && col < 3) {
+    return m[row][col];
+  } else {
+    Printf("RotationMatrix: index (%i,%i) out of bound\n", row, col);
+    return m[2][2];
+  }
 }
 
-const float& RotationMatrix::operator()(size_t row,size_t col) const {
-    if(row<3 && col<3) {
-        return m[row][col];
-    } else {
-        Printf("RotationMatrix: index (%i,%i) out of bound\n",row,col);
-        return m[2][2];
-    }
+const float &RotationMatrix::operator()(size_t row, size_t col) const {
+  if (row < 3 && col < 3) {
+    return m[row][col];
+  } else {
+    Printf("RotationMatrix: index (%i,%i) out of bound\n", row, col);
+    return m[2][2];
+  }
 }
 
Index: trunk/lib/FlairCore/src/SendData.cpp
===================================================================
--- trunk/lib/FlairCore/src/SendData.cpp	(revision 14)
+++ trunk/lib/FlairCore/src/SendData.cpp	(revision 15)
@@ -26,99 +26,93 @@
 using namespace flair::core;
 
-namespace flair
-{
-namespace gui
-{
+namespace flair {
+namespace gui {
 
-SendData::SendData(const LayoutPosition* position,string name,string type,uint16_t default_periodms,bool default_enabled) :Widget(position->getLayout(),name,type) {
-    pimpl_=new SendData_impl();
+SendData::SendData(const LayoutPosition *position, string name, string type,
+                   uint16_t default_periodms, bool default_enabled)
+    : Widget(position->getLayout(), name, type) {
+  pimpl_ = new SendData_impl();
 
-    pimpl_->send_size=0;
+  pimpl_->send_size = 0;
 
-    //default refesh rate: (ms)
-    pimpl_->send_period=default_periodms;
-    pimpl_->is_enabled=default_enabled;
+  // default refesh rate: (ms)
+  pimpl_->send_period = default_periodms;
+  pimpl_->is_enabled = default_enabled;
 
-    SetVolatileXmlProp("row",position->Row());
-    SetVolatileXmlProp("col",position->Col());
-    GetPersistentXmlProp("period",pimpl_->send_period);
-    SetPersistentXmlProp("period",pimpl_->send_period);
-    GetPersistentXmlProp("enabled",pimpl_->is_enabled);
-    SetPersistentXmlProp("enabled",pimpl_->is_enabled);
+  SetVolatileXmlProp("row", position->Row());
+  SetVolatileXmlProp("col", position->Col());
+  GetPersistentXmlProp("period", pimpl_->send_period);
+  SetPersistentXmlProp("period", pimpl_->send_period);
+  GetPersistentXmlProp("enabled", pimpl_->is_enabled);
+  SetPersistentXmlProp("enabled", pimpl_->is_enabled);
 
-    delete position;
+  delete position;
 
-    if(getUiCom()!=NULL) {
-        //register SendData for sending to ground station
-        getUiCom()->AddSendData(this);
-        //resume if necessary
-        getUiCom()->UpdateSendData(this);
-    }
+  if (getUiCom() != NULL) {
+    // register SendData for sending to ground station
+    getUiCom()->AddSendData(this);
+    // resume if necessary
+    getUiCom()->UpdateSendData(this);
+  }
 }
 
 SendData::~SendData() {
-    if(getUiCom()!=NULL) {
-        //unregister SendData for sending to ground station
-        getUiCom()->RemoveSendData(this);
-    }
+  if (getUiCom() != NULL) {
+    // unregister SendData for sending to ground station
+    getUiCom()->RemoveSendData(this);
+  }
 
-    delete pimpl_;
+  delete pimpl_;
 }
 
 void SendData::XmlEvent(void) {
-    uint16_t send_period;
-    bool is_enabled;
-    bool something_changed=false;
+  uint16_t send_period;
+  bool is_enabled;
+  bool something_changed = false;
 
-    if(GetPersistentXmlProp("period",send_period) && GetPersistentXmlProp("enabled",is_enabled)) {
-        if(send_period!=SendPeriod()) something_changed=true;
-        if(is_enabled!=IsEnabled()) something_changed=true;
-    }
+  if (GetPersistentXmlProp("period", send_period) &&
+      GetPersistentXmlProp("enabled", is_enabled)) {
+    if (send_period != SendPeriod())
+      something_changed = true;
+    if (is_enabled != IsEnabled())
+      something_changed = true;
+  }
 
-    if(something_changed) {
-        getFrameworkManager()->BlockCom();
+  if (something_changed) {
+    getFrameworkManager()->BlockCom();
 
-        SetSendPeriod(send_period);
-        SetEnabled(is_enabled);
+    SetSendPeriod(send_period);
+    SetEnabled(is_enabled);
 
-        getFrameworkManager()->UpdateSendData(this);
+    getFrameworkManager()->UpdateSendData(this);
 
-        //ack pour la station sol
-        //period and enabled are already in persistent prop
-        SetVolatileXmlProp("period",send_period);
-        SetVolatileXmlProp("enabled",is_enabled);
-        SendXml();
+    // ack pour la station sol
+    // period and enabled are already in persistent prop
+    SetVolatileXmlProp("period", send_period);
+    SetVolatileXmlProp("enabled", is_enabled);
+    SendXml();
 
-        getFrameworkManager()->UnBlockCom();
-    }
+    getFrameworkManager()->UnBlockCom();
+  }
 
-    ExtraXmlEvent();
+  ExtraXmlEvent();
 }
 
-size_t SendData::SendSize(void) const {
-    return pimpl_->send_size;
+size_t SendData::SendSize(void) const { return pimpl_->send_size; }
+
+uint16_t SendData::SendPeriod(void) const { return pimpl_->send_period; }
+
+bool SendData::IsEnabled(void) const { return pimpl_->is_enabled; }
+
+void SendData::SetEnabled(bool value) { pimpl_->is_enabled = value; }
+
+void SendData::SetSendSize(size_t value) {
+  pimpl_->send_size = value;
+
+  if (getUiCom() != NULL)
+    getUiCom()->UpdateDataToSendSize();
 }
 
-uint16_t SendData::SendPeriod(void) const {
-    return pimpl_->send_period;
-}
-
-bool SendData::IsEnabled(void) const {
-    return pimpl_->is_enabled;
-}
-
-void SendData::SetEnabled(bool value) {
-    pimpl_->is_enabled=value;
-}
-
-void SendData::SetSendSize(size_t value) {
-    pimpl_->send_size=value;
-
-    if(getUiCom()!=NULL) getUiCom()->UpdateDataToSendSize();
-}
-
-void SendData::SetSendPeriod(uint16_t value) {
-    pimpl_->send_period=value;
-}
+void SendData::SetSendPeriod(uint16_t value) { pimpl_->send_period = value; }
 
 } // end namespace core
Index: trunk/lib/FlairCore/src/SendData.h
===================================================================
--- trunk/lib/FlairCore/src/SendData.h	(revision 14)
+++ trunk/lib/FlairCore/src/SendData.h	(revision 15)
@@ -18,80 +18,78 @@
 class SendData_impl;
 
-namespace flair
-{
-namespace gui
-{
-    class LayoutPosition;
+namespace flair {
+namespace gui {
+class LayoutPosition;
 
-    /*! \class SendData
-    *
-    * \brief Abstract class for sending datas to ground station
-    *
-    */
-    class SendData: public Widget
-    {
-        public:
-            /*!
-            * \brief Constructor
-            *
-            */
-            SendData(const LayoutPosition* position,std::string name,std::string type,uint16_t default_periodms=100,bool default_enabled=false);
+/*! \class SendData
+*
+* \brief Abstract class for sending datas to ground station
+*
+*/
+class SendData : public Widget {
+public:
+  /*!
+  * \brief Constructor
+  *
+  */
+  SendData(const LayoutPosition *position, std::string name, std::string type,
+           uint16_t default_periodms = 100, bool default_enabled = false);
 
-            /*!
-            * \brief Destructor
-            *
-            */
-            virtual ~SendData();
+  /*!
+  * \brief Destructor
+  *
+  */
+  virtual ~SendData();
 
-            /*!
-            * \brief Copy datas to specified buffer
-            *
-            * This method must be reimplemented, in order to send datas to ground station.
-            *
-            * \param buf output buffer
-            */
-            virtual void CopyDatas(char* buf) const =0;
+  /*!
+  * \brief Copy datas to specified buffer
+  *
+  * This method must be reimplemented, in order to send datas to ground station.
+  *
+  * \param buf output buffer
+  */
+  virtual void CopyDatas(char *buf) const = 0;
 
-            size_t SendSize(void) const;
-            uint16_t SendPeriod(void) const; // in ms
-            bool IsEnabled(void) const;
+  size_t SendSize(void) const;
+  uint16_t SendPeriod(void) const; // in ms
+  bool IsEnabled(void) const;
 
-        protected:
+protected:
+  /*!
+  * \brief Notify that SenData's datas have changed
+  *
+  * This method must be called when the datas have changed. \n
+  * Normally, it occurs when a curve is added to a plot for example. \n
+  * This method automatically blocks and unblocks the communication.
+  *
+  */
+  void SetSendSize(size_t value);
 
-            /*!
-            * \brief Notify that SenData's datas have changed
-            *
-            * This method must be called when the datas have changed. \n
-            * Normally, it occurs when a curve is added to a plot for example. \n
-            * This method automatically blocks and unblocks the communication.
-            *
-            */
-            void SetSendSize(size_t value);
+  /*!
+  * \brief Extra Xml event
+  *
+  * This method must be reimplemented to handle extra xml event. \n
+  * It is automatically called when something changed from
+  * ground station, through XmlEvent method. \n
+  */
+  virtual void ExtraXmlEvent(void) = 0;
 
-            /*!
-            * \brief Extra Xml event
-            *
-            * This method must be reimplemented to handle extra xml event. \n
-            * It is automatically called when something changed from
-            * ground station, through XmlEvent method. \n
-            */
-            virtual void ExtraXmlEvent(void)=0;
+private:
+  /*!
+  * \brief XmlEvent from ground station
+  *
+  * Reimplemented from Widget. \n
+  * This method handles period and enabled properties of the SendData. \n
+  * Then it calls ExtraXmlEvent to handle specific xml events of reimplemented
+  *class.
+  *
+  */
+  void XmlEvent(void);
 
-        private:
-            /*!
-            * \brief XmlEvent from ground station
-            *
-            * Reimplemented from Widget. \n
-            * This method handles period and enabled properties of the SendData. \n
-            * Then it calls ExtraXmlEvent to handle specific xml events of reimplemented class.
-            *
-            */
-            void XmlEvent(void);
+  void SetSendPeriod(uint16_t value);
+  void SetEnabled(bool value);
 
-            void SetSendPeriod(uint16_t value);
-            void SetEnabled(bool value);
-
-            class SendData_impl* pimpl_;
-    };
+  class SendData_impl *pimpl_;
+};
 
 } // end namespace core
Index: trunk/lib/FlairCore/src/SendData_impl.cpp
===================================================================
--- trunk/lib/FlairCore/src/SendData_impl.cpp	(revision 14)
+++ trunk/lib/FlairCore/src/SendData_impl.cpp	(revision 15)
@@ -18,9 +18,5 @@
 #include "SendData_impl.h"
 
-SendData_impl::SendData_impl()
-{
-}
+SendData_impl::SendData_impl() {}
 
-SendData_impl::~SendData_impl()
-{
-}
+SendData_impl::~SendData_impl() {}
Index: trunk/lib/FlairCore/src/SerialPort.h
===================================================================
--- trunk/lib/FlairCore/src/SerialPort.h	(revision 14)
+++ trunk/lib/FlairCore/src/SerialPort.h	(revision 15)
@@ -17,76 +17,71 @@
 #include <stdint.h>
 
-namespace flair
-{
-namespace core
-{
-    /*! \class SerialPort
-    *
-    * \brief Base class for serial port
-    */
-    class SerialPort: public Object
-    {
-        public:
-            /*!
-            * \brief Constructor
-            *
-            * Construct a serial port.
-            *
-            * \param parent parent
-            * \param name name
-            */
-            SerialPort(const Object* parent,std::string name): Object(parent,name)
-            {}
+namespace flair {
+namespace core {
+/*! \class SerialPort
+*
+* \brief Base class for serial port
+*/
+class SerialPort : public Object {
+public:
+  /*!
+  * \brief Constructor
+  *
+  * Construct a serial port.
+  *
+  * \param parent parent
+  * \param name name
+  */
+  SerialPort(const Object *parent, std::string name) : Object(parent, name) {}
 
-            /*!
-            * \brief Destructor
-            *
-            */
-            ~SerialPort(){};
+  /*!
+  * \brief Destructor
+  *
+  */
+  ~SerialPort(){};
 
-            /*!
-            * \brief Set baudrate
-            *
-            * \param baudrate baudrate
-            *
-            */
-            virtual void SetBaudrate(int baudrate)=0;
+  /*!
+  * \brief Set baudrate
+  *
+  * \param baudrate baudrate
+  *
+  */
+  virtual void SetBaudrate(int baudrate) = 0;
 
-            /*!
-            * \brief Set RX timeout
-            *
-            * Timeout for waiting datas.
-            *
-            * \param timeout_ns timeout in nano second
-            */
-            virtual void SetRxTimeout(Time timeout_ns)=0;
+  /*!
+  * \brief Set RX timeout
+  *
+  * Timeout for waiting datas.
+  *
+  * \param timeout_ns timeout in nano second
+  */
+  virtual void SetRxTimeout(Time timeout_ns) = 0;
 
-            /*!
-            * \brief Write datas
-            *
-            * \param buf pointer to datas
-            * \param nbyte length of datas
-            *
-            * \return amount of written datas
-            */
-            virtual ssize_t Write(const void *buf,size_t nbyte)=0;
+  /*!
+  * \brief Write datas
+  *
+  * \param buf pointer to datas
+  * \param nbyte length of datas
+  *
+  * \return amount of written datas
+  */
+  virtual ssize_t Write(const void *buf, size_t nbyte) = 0;
 
-            /*!
-            * \brief Read datas
-            *
-            * \param buf pointer to datas
-            * \param nbyte length of datas
-            *
-            * \return amount of read datas
-            */
-            virtual ssize_t Read(void *buf,size_t nbyte)=0;
+  /*!
+  * \brief Read datas
+  *
+  * \param buf pointer to datas
+  * \param nbyte length of datas
+  *
+  * \return amount of read datas
+  */
+  virtual ssize_t Read(void *buf, size_t nbyte) = 0;
 
-            /*!
-            * \brief Flush input datas
-            *
-            */
-            virtual void FlushInput(void)=0;
-
-    };
+  /*!
+  * \brief Flush input datas
+  *
+  */
+  virtual void FlushInput(void) = 0;
+};
 } // end namespace core
 } // end namespace framework
Index: trunk/lib/FlairCore/src/SharedMem.cpp
===================================================================
--- trunk/lib/FlairCore/src/SharedMem.cpp	(revision 14)
+++ trunk/lib/FlairCore/src/SharedMem.cpp	(revision 15)
@@ -21,28 +21,19 @@
 using std::string;
 
-namespace flair
-{
-namespace core
-{
+namespace flair {
+namespace core {
 
-SharedMem::SharedMem(const Object* parent,string name,size_t size): Object(parent,name,"shmem")
-{
-    pimpl_=new SharedMem_impl(this,name,size);
+SharedMem::SharedMem(const Object *parent, string name, size_t size)
+    : Object(parent, name, "shmem") {
+  pimpl_ = new SharedMem_impl(this, name, size);
 }
 
-SharedMem::~SharedMem()
-{
-    delete pimpl_;
+SharedMem::~SharedMem() { delete pimpl_; }
+
+void SharedMem::Write(const char *buf, size_t size) {
+  pimpl_->Write(buf, size);
 }
 
-void SharedMem::Write(const char* buf,size_t size)
-{
-    pimpl_->Write(buf,size);
-}
-
-void SharedMem::Read(char* buf,size_t size) const
-{
-    pimpl_->Read(buf,size);
-}
+void SharedMem::Read(char *buf, size_t size) const { pimpl_->Read(buf, size); }
 
 } // end namespace core
Index: trunk/lib/FlairCore/src/SharedMem.h
===================================================================
--- trunk/lib/FlairCore/src/SharedMem.h	(revision 14)
+++ trunk/lib/FlairCore/src/SharedMem.h	(revision 15)
@@ -19,56 +19,53 @@
 class SharedMem_impl;
 
-namespace flair
-{
-namespace core
-{
+namespace flair {
+namespace core {
 
-    /*! \class SharedMem
-    *
-    * \brief Class defining a shared memory
-    *
-    * Shared memory is identified by its name so it can be accessed
-    * by another processus using its name.
-    */
+/*! \class SharedMem
+*
+* \brief Class defining a shared memory
+*
+* Shared memory is identified by its name so it can be accessed
+* by another processus using its name.
+*/
 
-    class SharedMem: public Object
-    {
-        public:
-            /*!
-            * \brief Constructor
-            *
-            * Construct a shared memory object
-            *
-            * \param parent parent
-            * \param name name
-            * \param size size of the shared memory
-            */
-            SharedMem(const Object* parent,std::string name,size_t size);
+class SharedMem : public Object {
+public:
+  /*!
+  * \brief Constructor
+  *
+  * Construct a shared memory object
+  *
+  * \param parent parent
+  * \param name name
+  * \param size size of the shared memory
+  */
+  SharedMem(const Object *parent, std::string name, size_t size);
 
-            /*!
-            * \brief Destructor
-            *
-            */
-            ~SharedMem();
+  /*!
+  * \brief Destructor
+  *
+  */
+  ~SharedMem();
 
-            /*!
-            * \brief Write
-            *
-            * \param buf input buffer to write to memory
-            * \param size buffer size
-            */
-            void Write(const char* buf,size_t size);
+  /*!
+  * \brief Write
+  *
+  * \param buf input buffer to write to memory
+  * \param size buffer size
+  */
+  void Write(const char *buf, size_t size);
 
-            /*!
-            * \brief Read
-            *
-            * \param buf output buffer to write from memory
-            * \param size buffer size
-            */
-            void Read(char* buf,size_t size) const;
+  /*!
+  * \brief Read
+  *
+  * \param buf output buffer to write from memory
+  * \param size buffer size
+  */
+  void Read(char *buf, size_t size) const;
 
-        private:
-            SharedMem_impl* pimpl_;
-    };
+private:
+  SharedMem_impl *pimpl_;
+};
 
 } // end namespace core
